# FIXME: %{kversuffix} will be empty unless you run the toplevel
# `make rpms'.  I see no way to have the RPM get this information
# into the package file, because RPM doesn't provide shell callouts.
%define kversuffix %{?KVER:-%{KVER}}

Summary: InterMezzo synchronization client
Name: intersync
Version: 0.9.5
Release: 1

URL: http://www.clusterfilesystems.com
Source0: %{name}-%{version}.tar.gz
License: GPL
Group: Networking/Daemons
BuildRoot: %{_tmppath}/%{name}-root
Requires: apache

%description 
InterSync is a C based InterMezzo client, intended to
operate with an http server (e.g. TUX or Apache) as a server. 

%package module%{kversuffix}
Summary: InterMezzo kernel module
Group: Development/Kernel
Provides: intersync-module

%description module%{kversuffix}
This intersync-module package contains the intermezzo.o Linux kernel
module needed to track modifications to the cache filesystems.

%prep
%setup -q

%build
./configure
make -j2 all

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/var/log/intermezzo
mkdir -p $RPM_BUILD_ROOT/etc/intermezzo
install -c sampleconfigs/intersync.conf $RPM_BUILD_ROOT/etc/intermezzo
# prepare intermezzo as a standalone source project
tmpdir=/tmp/izo-%{version}
rm -rf $tmpdir
cp -pr fs24 $tmpdir
( cd $tmpdir &&
  make distclean &&
  automake --copy --add-missing &&
  aclocal &&
  autoconf) || /bin/false
mkdir -p  $RPM_BUILD_ROOT/usr/src
cp -pr $tmpdir $RPM_BUILD_ROOT/usr/src/intermezzo-%{version}
rm -rf $tmpdir

%clean
rm -rf $RPM_BUILD_ROOT

%post -n intersync-module%{kversuffix}
depmod -ae

%postun -n intersync-module%{kversuffix}
depmod -ae

%pre
GROUPNAME=intermezzo
if grep "^${GROUPNAME}:" /etc/group >/dev/null; then :
else
    # Try the default group.
    err=`groupadd -g 4711 $GROUPNAME`
    status=$?
    if test $status != 0 && test $status != 9; then
        err=`groupadd $GROUPNAME`
        status=$?
        if test $status != 0 && test $status != 9; then
            echo "$err"
            exit $status
        fi
    fi
fi

err=`useradd -g $GROUPNAME -d / -s /bin/true intermezzo 2>&1`
status=$?
if test $status != 0 && test $status != 9; then
   echo "$err"
   exit $status
fi

%post
chkconfig --add intersync

FSNAME=InterMezzo
MODNAME=intermezzo
DEVMAJOR=185

if grep $FSNAME /proc/filesystems >/dev/null; then :
elif modprobe $MODNAME; then
    rmmod $MODNAME
else
    echo "WARNING: your currently running kernel does not contain InterMezzo"
fi

if test -f /etc/modules.conf && \
   grep -q "char\-major\-$DEVMAJOR" /etc/modules.conf; then :
else
    echo "alias char-major-$DEVMAJOR $MODNAME" >> /etc/modules.conf
fi

cat <<EOF

The current intermezzo module source code has been installed on 
this system and needs to be compiled for the current kernel. 
Please run the following commands:

 cd /usr/src/intermezzo-%{version}
 ./configure
 make install

For more information, see the InterSync HOWTO,
/usr/share/doc/%{name}-%{version}/InterSync-HOWTO.html
EOF

%preun
chkconfig --del intersync || :

%postun
if [ "$1" -eq 0 ]; then
     userdel intermezzo
     groupdel intermezzo
fi

%files
%defattr(-,root,root)
/etc/init.d/*
/usr/bin/*
/usr/lib/lib*
/usr/lib/intermezzo/*
/usr/include/intermezzo/*
/usr/share/man/man[458]/*
/var/log/intermezzo
/usr/src/intermezzo-*

%doc COPYING ChangeLog NEWS INSTALL
%doc doc/*.txt doc/*.sgml doc/*.html

%config /etc/intermezzo/intersync.conf


#%files module%{kversuffix}
#%defattr(-,root,root)
#/lib/modules/*

%doc fs24/COPYING fs24/ChangeLog fs24/NEWS fs24/INSTALL

%changelog
* Wed Apr 24 2002 Robert Read <rread@computer.org>
- Install intermezzo source files 

* Wed Feb 20 2002 Robert Read <rread@computer.org>
- Don't build kernel module (crude, but effective)

* Wed Feb 20 2002 Phil Schwan <phil@clusterfs.com>
- CGIs are now installed in /usr/lib/intermezzo

* Fri Jan 26 2002 Gordon Matzigkeit <gord@fig.org>
- Updated.

* Fri Nov 23 2001 Peter J. Braam <braam@clusterfs.com>
- Initial packaging for intersync

