#ifndef INWALKER_H__
#define INWALKER_H__ 1

#include <glib.h>
#include <linux/intermezzo_idl.h>

#if 0
/* FIXME: This is awful.  We should decide on a header strategy that lets us
 * share things like this between presto and userspace.  It's not hard, we
 * just need to agree. -phil */

/* Derived, ahem, copied from linux/intermezzo_kml.h */

#define PRESTO_KML_MAJOR_VERSION 0x00010000
#define PRESTO_KML_MINOR_VERSION 0x00002001
#define PRESTO_OP_NOOP          0
#define PRESTO_OP_CREATE        1
#define PRESTO_OP_MKDIR         2
#define PRESTO_OP_UNLINK        3
#define PRESTO_OP_RMDIR         4
#define PRESTO_OP_CLOSE         5
#define PRESTO_OP_SYMLINK       6
#define PRESTO_OP_RENAME        7
#define PRESTO_OP_SETATTR       8
#define PRESTO_OP_LINK          9
#define PRESTO_OP_OPEN          10
#define PRESTO_OP_MKNOD         11
#define PRESTO_OP_WRITE         12
#define PRESTO_OP_RELEASE       13
#define PRESTO_OP_TRUNC         14
#define PRESTO_OP_SETEXTATTR    15
#define PRESTO_OP_DELEXTATTR    16

#define PRESTO_LML_DONE     	1 /* flag to get first write to do LML */
#define KML_KOP_MARK            0xffff

struct journal_prefix {
        guint32 len;
        guint32 version; 
        guint32 pid;
        guint32 uid;
        guint32 fsuid;
        guint32 fsgid;
        guint32 opcode;
        guint32 ngroups;
        guint32 groups[0];
};

struct journal_suffix {
	unsigned long prevrec;  /* offset of previous record for dentry */
	int recno;
	int time;
	int len;
};

enum kml_opcode {
        KML_CREATE = 1,
        KML_MKDIR,
        KML_UNLINK,
        KML_RMDIR,
        KML_CLOSE,
        KML_SYMLINK,
        KML_RENAME,
        KML_SETATTR,
        KML_LINK,
        KML_OPEN,
        KML_MKNOD,
        KML_ENDMARK = 0xff
};

struct presto_version {
        guint64 pv_mtime;
        guint64 pv_ctime;
        guint64 pv_size;
};

struct kml_close {
        int                     open_mode, 
                                open_uid, 
                                open_gid;
        char                    *path;
        struct presto_version   new_objectv;
        guint64                 ino;
        int                     generation;
};

struct kml_mkdir {
        char                    *path;
        struct presto_version   new_objectv, 
                                old_parentv, 
                                new_parentv;
        int                     mode;
        int                     uid;
        int                     gid;
};

struct kml_mknod {
        char                    *path;
        struct presto_version   new_objectv, 
                                old_parentv, 
                                new_parentv;
        int                     mode;
        int                     uid;
        int                     gid;
        int                     major;
        int                     minor;
};

struct kml_symlink {
        char                    *sourcepath,    
                                *targetpath;
        struct presto_version   new_objectv, 
                                old_parentv, 
                                new_parentv;
        int                     uid;
        int                     gid;
};

struct kml_link {
        char                    *sourcepath,    
                                *targetpath;
        struct presto_version   new_objectv, 
                                old_parentv, 
                                new_parentv;
};
#endif

#endif
